//==========================================================================
// Mouse Injector Plugin
//==========================================================================
// Copyright (C) 2017 Carnivorous
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL CARNIVOROUS BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
#define __MOUSE_INECTOR_VERSION__ "V1.4"
#define __CURRENTYEAR__ "2017"
#define CONSOLE { AllocConsole(); AttachConsole(GetCurrentProcessId()); freopen("CON", "w", stdout); }
#define ONLY1PLAYERACTIVE \
PROFILE[PLAYER1].SETTINGS[CONFIG] != DISABLED && PROFILE[PLAYER2].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER3].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER4].SETTINGS[CONFIG] == DISABLED || \
PROFILE[PLAYER1].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER2].SETTINGS[CONFIG] != DISABLED && PROFILE[PLAYER3].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER4].SETTINGS[CONFIG] == DISABLED || \
PROFILE[PLAYER1].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER2].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER3].SETTINGS[CONFIG] != DISABLED && PROFILE[PLAYER4].SETTINGS[CONFIG] == DISABLED || \
PROFILE[PLAYER1].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER2].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER3].SETTINGS[CONFIG] == DISABLED && PROFILE[PLAYER4].SETTINGS[CONFIG] != DISABLED

// Controller plugin's
#define PLUGIN_TYPE_CONTROLLER 4

#define PLUGIN_NONE 1
#define PLUGIN_MEMPAK 2
#define PLUGIN_RUMBLE_PAK 3 // not implemeted for non raw data
#define PLUGIN_TANSFER_PAK 4 // not implemeted for non raw data

// Structures (Note: BOOL, BYTE, WORD, DWORD, TRUE, FALSE are defined in windows.h)
#ifndef _WINDOWS_
	typedef unsigned short WORD;
	typedef int BOOL;
	typedef unsigned long DWORD;
#endif

typedef struct
{
	WORD Version; // Should be set to 0x0100
	WORD Type; // Set to PLUGIN_TYPE_CONTROLLER
	char Name[100]; // Name of the DLL
	BOOL Reserved1;
	BOOL Reserved2;
} PLUGIN_INFO;

typedef struct
{
	BOOL Present;
	BOOL RawData;
	int Plugin;
} CONTROL;

typedef union
{
	DWORD Value;
	struct
	{
		unsigned R_DPAD: 1;
		unsigned L_DPAD: 1;
		unsigned D_DPAD: 1;
		unsigned U_DPAD: 1;
		unsigned START_BUTTON: 1;
		unsigned Z_TRIG: 1;
		unsigned B_BUTTON: 1;
		unsigned A_BUTTON: 1;

		unsigned R_CBUTTON: 1;
		unsigned L_CBUTTON: 1;
		unsigned D_CBUTTON: 1;
		unsigned U_CBUTTON: 1;
		unsigned R_TRIG: 1;
		unsigned L_TRIG: 1;
		unsigned Reserved1: 1;
		unsigned Reserved2: 1;

		signed Y_AXIS: 8;

		signed X_AXIS: 8;
	};
} BUTTONS;

BUTTONS CONTROLLER[4]; // end of plugin spec

// profile struct
enum CONTROLLERENUM {FORWARDS, BACKWARDS, STRAFELEFT, STRAFERIGHT, FIRE, AIM, ACCEPT, CANCEL, START, CROUCH, PREVIOUSWEAPON, NEXTWEAPON, UP, DOWN, LEFT, RIGHT};
enum CONFIGENUM {CONFIG, SENSITIVITY, ACCELERATION, CROSSHAIR, INVERTPITCH, CROUCHTOGGLE, GEAIMMODE, PDRADIALNAV, MOUSE, KEYBOARD};
enum QUICKCONFIGENUM {DISABLED, WASD, ESDF, CUSTOM};
enum PLAYERSENUM {PLAYER1, PLAYER2, PLAYER3, PLAYER4, ALLPLAYERS};

struct
{
	int BUTTONPRIM[16];
	int BUTTONSEC[16];
	int SETTINGS[10];
} PROFILE[4];

// device struct (used for all game input)
struct
{
	int XPOS, YPOS; // mouse input
	int WHEEL; // mouse wheel buffer cool down
	int BUTTONPRIM[16]; // button values for primary set (0-1)
	int BUTTONSEC[16]; // button values for secondary set (0-1)
	int ARROW[4]; // arrow information
} DEVICE[4];