//==========================================================================
// Mouse Injector Plugin
//==========================================================================
// Copyright (C) 2017 Carnivorous
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL CARNIVOROUS BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
#define DLLEXPORT __declspec(dllexport)
#define CALL __cdecl

HINSTANCE hInst = NULL;
pthread_t injectthread = NULL; // thread identifier
wchar_t inifilepath[MAX_PATH]; // mouseinjector.ini filepath
const char inifilepathdefault[MAX_PATH] = ".\\plugin\\mouseinjector.ini"; // mouseinjector.ini filepath (safe default char type)
int stopthread = 1; // 1 to end inject thread
int lastinputbutton = 0; // used to check and see if user pressed button twice in a row (avoid loop for spacebar/enter/click)
int currentplayer = PLAYER1;
int mousetogglekey = 0x34; // default key is 4
int mousetoggle = 0; // mouse lock
int mouselockonfocus = 0; // auto lock mouse when 1964 is focused
int defaultmouse = -1, defaultkeyboard = -1;
int currentlyconfiguring = 0;
HWND emulatorwindow = NULL;
CONTROL *ctrlptr;
int emuoverclock = 1; // is this emu overclocked?
int overridefov = 60; // fov override
int changeratio = 0; // used to display different hoz fov for 4:3/16:9 ratio

// external functions/variables from device.c
extern int windowactive;
extern int DEV_Init(void);
extern void *DEV_PollInput();
extern int DEV_ReturnKey(void);
extern int DEV_ReturnDeviceID(const int kbflag);
extern const char *DEV_Name(const int id);
extern int DEV_Type(const int id);
extern int DEV_TypeIndex(const int id);
extern int DEV_TypeID(const int id, const int kbflag);
// external functions/variables from game.c
extern void GAME_Quit(void);
// external functions/variables from memory.c
extern const unsigned char **rdramptr;
extern const unsigned char **romptr;

int Init(HWND hW);
void End(void);
void StartPolling(void);
void StopPolling(void);
BOOL CALLBACK GUI_Config(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
void GUI_Init(const HWND hW);
void GUI_Refresh(const HWND hW, const int revertbtn);
void GUI_ProcessKey(const HWND hW, const int buttonid, const int primflag);
void GUI_DetectDevice(const HWND hW, const int buttonid);
void INI_Load(const HWND hW, const int loadplayer);
void INI_Save(const HWND hW);
void INI_Reset(const int playerflag);
void INI_SetConfig(const int playerflag, int config);
void UpdateControllerStatus(void);
DLLEXPORT void CALL CloseDLL(void);
DLLEXPORT void CALL ControllerCommand(int Control, BYTE *Command);
DLLEXPORT void CALL DllAbout(HWND hParent);
DLLEXPORT void CALL DllConfig(HWND hParent);
DLLEXPORT void CALL DllTest(HWND hParent);
DLLEXPORT void CALL GetDllInfo(PLUGIN_INFO *PluginInfo);
DLLEXPORT void CALL GetKeys(int Control, BUTTONS* Keys);
DLLEXPORT void CALL InitiateControllers(HWND hMainWindow, CONTROL Controls[4]);
DLLEXPORT void CALL ReadController(int Control, BYTE *Command);
DLLEXPORT void CALL RomClosed(void);
DLLEXPORT void CALL RomOpen(void);
DLLEXPORT void CALL WM_KeyDown(WPARAM wParam, LPARAM lParam);
DLLEXPORT void CALL WM_KeyUp(WPARAM wParam, LPARAM lParam);
DLLEXPORT void CALL HookRDRAM(DWORD *Mem, int OCFactor);
DLLEXPORT void CALL HookROM(DWORD *Rom);